/*global $ */
"use strict";
$.restart = function() {
    return $.post("/stereo/restart");
};

$.waitForApp = function(callback, minimum_wait) {
    var deferred = $.Deferred();
    if ( minimum_wait == undefined ) {
        minimum_wait = 2000;
    }
    var pollTimer, timeoutTimer;
    setTimeout(function() {
        var timer = 0;
        function pollStarted() {
            $.ajax("/stereo/fps.json", {
                success: function (data) {
                    if (data && data.frames > 10 ) {
                        $("#overlay").hide();
                        clearTimeout(timeoutTimer);
                        if (callback) callback();
                        deferred.resolve();
                    } else {
                        pollTimer = setTimeout(pollStarted, 2000);
                    }
                }, error: function() {
                    pollTimer = setTimeout(pollStarted, 2000);
                }
            });
        }
        pollStarted();
    }, minimum_wait);
    $("#overlay").show();
    timeoutTimer = setTimeout(function() {
        clearTimeout(pollTimer);
        deferred.reject();
        alert("The application does not seem to start. Redirecting to application menu.");
        window.location = "/admin/devtools.shtml";
    }, 200000);
    return deferred;
};

$.restartAndWait = function() {
    return $.when(
        $.restart(),
        $.waitForApp(false, 5000)
    );
};

$(function () {
    $(".ctrlHolder input, .ctrlHolder select, .ctrlHolder .ui-slider-handle").on("focus", function () {
        $(this).parents(".ctrlHolder:first").addClass("focused");
    }).on("blur", function () {
        $(this).parents(".ctrlHolder:first").removeClass("focused");
    });
    $(".helpIcon").each(function () {
        var $icon = $(this),
            $text = $("#" + $icon.attr("for"));
        $icon.click(function () {
            if ($icon.hasClass("active")) {
                $text.slideUp();
                $icon.removeClass("active").removeClass("stick-active");
            } else {
                $text.slideDown().css("display", "inline-block");
                $icon.addClass("active").addClass("stick-active");
            }
        });
    });
    $(".flash").each(function () {
        var $flash = $(this);
        setTimeout(function () {
            $flash.slideUp();
        }, 5000);
    });
    $.fn.addLoader = function (type,  skip_disable) {
        var $element = $(this[0]),
            loader_src,
            $loader;
        if (typeof skip_disable === "undefined") {
            skip_disable = false;
        }
        if (type === "light") {
            loader_src = "/static/image/ajax-loader-light.gif";
        } else {
            //Default
            loader_src = "/static/image/ajax-loader.gif";
        }
        $loader = $("<div/>")
                .addClass("loaderWrapper")
                .append(
                $("<img/>")
                    .attr("src", loader_src)
                    .addClass("loader")
            );
        $element.append($loader);
        if (!skip_disable) {
            this.prop("disabled", true);
        }
        return this;
    };
    $.fn.removeLoader = function () {
        var $element = $(this[0]);
        $element.find(".loaderWrapper").remove();
        this.prop("disabled", false);
        return this;
    };
    var now = new Date(TIMETUPLE[0], TIMETUPLE[1] - 1, TIMETUPLE[2], TIMETUPLE[3], TIMETUPLE[4], TIMETUPLE[5]);
    $('#theclockbar').clockbar(now);
});
