$.fn.simpleIndicator = function(options) {
    var opts = $.extend({}, $.fn.simpleIndicator.defaults, options);
    var canvas = $("<canvas>"),
        ctx = canvas[0].getContext("2d");
    var is_waiting = false;
    var correct_response = false;
    var current = [];
    var $elems = [];
    var i;
    for(i = 0; i < opts.indicators; i++){
        current.push(false);
        var $e = $("<div/>").css({
            "background-color": opts.backgroundColor,
            "width": "100%",
            "height": opts.height,
            "position": "absolute",
            "left": "1px",
            "top": opts.height * i +  "px",
            "color": "white",
            "font-size":  opts.height - 1 + "px",
        }).appendTo(this);
        $elems.push($e);
    }
    $(this).css("position", "relative");

    canvas.attr("height", opts.height);
    canvas.attr("width", opts.width);

    canvas.appendTo(this);

    function redraw() {
        for(i = 0; i < opts.indicators; i++) {
            $elems[i].hide();
        }
        i = 0;
        for(var j in current) {
            if ( current[j] ) {
                $elems[i].show()
                    .html("Input " + j + " is active")
                    .css("opacity", 0.7);
                i++;
            }
        }
        if ( i === 0 ) {
            $elems[i].show()
                .html("No input active.")
                .css("opacity", 0.3);
        }
    }

    refresh();

    function refresh() {
        is_waiting = true;
        correct_response = false;
        redraw();
        $.ajax({
            cache: false,
            url: opts.url,
            success: function(data) {
                current = opts.mapper(data);
                is_waiting = false;
                correct_response = true;
                redraw();
                setTimeout(refresh, 2000);
            }, error: function() {
                is_waiting = false;
                setTimeout(refresh, 5000);
                redraw();
            }
        });
    }
};

$.fn.simpleIndicator.defaults = {
    url: "/stereo/io.json",
    mapper: function(data) {
        return data.input;
    },
    height: 14,
    width: 100,
    indicators: 4,
    backgroundColor: "black",
    colorOn: "green",
    colorOff: "gray"
};
