/*global $, WARNINGS, APP_NAME*/
"use strict";
$(function () {
    function update_ui(warnings, speed) {
        var iterate_warnings = [];
        $("#errors .error").data("keep", false);
        if (warnings.hasOwnProperty("all")) {
            iterate_warnings = iterate_warnings.concat(warnings.all);
        }
        if (typeof(APP_NAME) !== 'undefined' && warnings.hasOwnProperty(APP_NAME)) {
            iterate_warnings = iterate_warnings.concat(warnings[APP_NAME]);
        }
        $.each(iterate_warnings, function (i, warning) {
            var cls = "id" + warning.id,
                $el = $(".error." + cls);
            if ($el.length) {
                $el.data("keep", true);
            } else {
                $el = $("<div/>")
                    .data("keep", true)
                    .addClass(cls)
                    .addClass("error")
                    .appendTo("#errors")
                    .html(warning.text);
                if (speed === 0) {
                    $el.show();
                } else {
                    $el.addClass("noText").hide().slideDown(speed, function () {
                        $(this).hide().fadeIn(speed).removeClass("noText");
                    });
                }
            }
        });
        var r = $("#errors .error").filter(function () {
            return $(this).data("keep") === false;
        }).fadeOut(speed, function () {
            $(this).addClass("noText").show().slideUp(300, function () {
                $(this).remove();
            });
        });
    }

    function is_ie10() {
        return window.navigator.userAgent.indexOf('MSIE ') != -1;
    }

    var warnings_counter = 0
    function update_warnings() {
        $.ajax({
            url: "/stereo/warnings.json",
            timeout: 90000,
            data: {old_count: warnings_counter},
            success: function (data, textStatus, xhr) {
                if (xhr.status != 204) {
                    if (is_ie10()) {
                        data.warnings.all.push(
                                { "id": "MSIE10Warning",
                                  "text": "You are using Internet Explorer 10, " +
                                      "which is not supported by our video player." +
                                      "To view the video, please update your browser to at least Internet Explorer 11 or use an alternative browser such as Firefox or Chrome(ium)."});
                    }
                    update_ui(data.warnings, 300);
                    warnings_counter = data.old_count
                }
            },
            complete: function() {
                setTimeout(update_warnings, 10000) // Poll no more frequently than once every 10s
            }
        });
    }
    setTimeout(update_warnings, 1000);
    update_ui(WARNINGS, 0);
});
